/*****************************************************************************
* Copyright (c) Future Technology Devices International 2014
* propriety of Future Technology devices International.
*
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by FTDI. 
* FTDI accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file                           Sender_Enhanced_HW_Flow_Ctl_2.ino
* @brief                          Sketch to demonstrate enhanced hardware flow control functionality for VI800A-TTLU add-on module.
								  Tested platform version: Arduino 1.0.4 and later
* @version                        1.0.0
* @date                           2014/10/01
*
*/


/* Arduino standard includes */
#include "SPI.h"
#include "Wire.h"

/* Platform specific includes */
#include "FT_VI800A_TTLU.h"

FT_VI800A VI800A;

void setup()
{
	/* Initialize serial print related functionality */
	Serial.begin(9600);
    Serial.println("\n\r\n\r-----------Sender_Enhanced_HW_Flow_Ctl_2.ino--------------");
	
	//initialize function, same as calling 
	VI800A.Init(FT_TTLU_CS,921600,FT_VI800A_No_Parity, FT_VI800A_One_Stop_Bit, FT_VI800A_Eight_Data_Bits);
	VI800A.SetFlowControl(FT_VI800A_HW_Flow, FT_VI800A_Use_No_RX_Trigger);

}

char value[] = {'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'};
uint8_t valueIndex=0;
uint8_t command, manualStart=0;

void loop()
{

   if(Serial.available() > 0)
   {
		command = Serial.read();
		if(command == 'p')
		{
			manualStart=1;
		}
   }
   
   if(manualStart && (VI800A.GetTransmitFIFOFreeSpace())){
		if(VI800A.Write(value[valueIndex])==0)
			Serial.println("Data not in FIFO");
		delay(5);
		while(!VI800A.isTransmitFIFOandShiftRegisterEmpty()){
				Serial.print("Waiting to send: ");
				Serial.println((char)value[valueIndex]);
		}
		Serial.print("Sent: ");
		Serial.println(value[valueIndex]);
		valueIndex=(valueIndex+1)%26;
   }
}









































